#include <d3d8.h>
#include <d3dx8.h>

#define DXTestFmt(x) if (TestFormat(x)) {format=x; break;}
#define DXTestDepth(x) if (TestDepth(x)) zFormat=x

// Some D3DCOLOR shortcut macros:
#define DRGBA(r,g,b,a)      ((D3DCOLOR)((((a)&0xff)<<24)|(((r)&0xff)<<16)|(((g)&0xff)<<8)|((b)&0xff)))
#define DRGB(r,g,b)      ((D3DCOLOR)(((0xff)<<24)|(((r)&0xff)<<16)|(((g)&0xff)<<8)|((b)&0xff)))
#define GetB(rgb) ((BYTE)(rgb))
#define GetG(rgb) ((BYTE)(((WORD)(rgb)) >> 8))
#define GetR(rgb) ((BYTE)((rgb)>>16))
#define GetA(rgb) ((BYTE)((rgb)>>24))
// Flags Used by DrawRect()
#define DR3DLOOK 0x01
#define DDBLTFX_MIRRORLEFTRIGHT 1
#define DDBLTFX_MIRRORUPDOWN 2
#define DDERR_INVALIDPARAMS E_FAIL
#define DR3DLOOK2 0x02

//-----------------------------------------------------------------------------
// DX8 Information Class - a convenient, single place to store global DX vars
//-----------------------------------------------------------------------------

class DX8VARS {
public:
	LPDIRECT3D8 pD3D; // Used to create the D3DDevice
	LPDIRECT3DDEVICE8 pd3dDevice; // Our rendering device
	LPD3DXSPRITE pd3dxSprite; // Interface to Sprite routines
	IDirect3DVertexBuffer8 *pStreamData; //Vertex for ???
	IDirect3DIndexBuffer8 * pIndexBuffer; //I have no Idea
	IDirect3DTexture8 * pTexture; //Holds Texture.  Just one
	D3DCAPS8 *pd3dcaps; // Caps for the rendering device
	bool Active;
	// Constructor/Destructor:
	DX8VARS() { pD3D = NULL; pd3dDevice = NULL; pd3dxSprite = NULL; Active = true;
	pd3dcaps = new D3DCAPS8; }
	~DX8VARS() { if (pd3dcaps) delete pd3dcaps; }
	// If you feel very object-oriented, you could make InitD3D(), Cleanup()
	// and Render() all methods of the DX8VARS class.
};

struct MYVERTEX{
  FLOAT x, y, z; // The transformed position
  FLOAT rhw;     // 1.0 (reciprocal of homogeneous w)
  DWORD color;   // The vertex color
};

//----------------------------------------------------------------------------
// Function Prototypes
//----------------------------------------------------------------------------

HRESULT InitD3D( HWND hWnd , WORD width = 640, WORD height = 480, WORD wDepth=16,
				WORD wBackBuffers=1, BOOL bWindowed = false);

BOOL TestFormat(D3DFORMAT fmt);

BOOL TestDepth(D3DFORMAT fmt);

void Cleanup();

HRESULT DrawRect(RECT rc, DWORD fillstyle, D3DCOLOR fillcolor, int bordersize, 
          D3DCOLOR bordercolor, DWORD drflags);

HRESULT BltSpriteEx( RECT *pDestRect, LPDIRECT3DTEXTURE8 pSrcTexture, 
               RECT *pSrcRect, DWORD dwFlags, D3DCOLOR modulate = 0xFFFFFFFF, 
               float rotation = 0, POINT *prcenter = NULL );

HRESULT BltSprite( RECT *pDestRect, LPDIRECT3DTEXTURE8 pSrcTexture, 
          RECT *pSrcRect, DWORD dwFlags );

LPDIRECT3DTEXTURE8 LoadTexture(char *filename);

//----------------------------------------------------------------------------
// Global variables
//----------------------------------------------------------------------------

extern DX8VARS dx8;
